<?php
	
function ipmi_MetaData() {
	return ['DisplayName' => 'Server IPMI'];
}

function ipmi_AdminLink($params) {
	$ipmiip = $params['customfields']["ipmiip"];
	$ipmiuser = $params['customfields']["ipmiuser"];
	$ipmipass = $params['customfields']["ipmipass"];
	$code = "<a href=\"https://$ipmiip/\" target=\"_blank\" style=\"color:#cc0000\">登陆到IPMI页面</a>";
	return $code;
}

function ipmi_LoginLink($params) {
	$ipmiip = $params['customfields']["ipmiip"];
	$ipmiuser = $params['customfields']["ipmiuser"];
	$ipmipass = $params['customfields']["ipmipass"];
	$code = "<a href=\"https://$ipmiip/\" target=\"_blank\" style=\"color:#cc0000\">登陆到IPMI页面</a>";
	return $code;
}

// 重启
function ipmi_reboot($params) {
	$ipmiip = $params['customfields']["ipmiip"];
	$ipmiuser = $params['customfields']["ipmiuser"];
	$ipmipass = $params['customfields']["ipmipass"];
	$cmd="ipmitool -H $ipmiip -U $ipmiuser -P $ipmipass -I lanplus power reset";
	$return=exec($cmd);
	if($return ==""){
		$status = "fail";
	}else{
		$status = "success";
	}
	return $status;
}
// 关机
function ipmi_powerOff($params) {
	$ipmiip = $params['customfields']["ipmiip"];
	$ipmiuser = $params['customfields']["ipmiuser"];
	$ipmipass = $params['customfields']["ipmipass"];
	$cmd="ipmitool -H $ipmiip -U $ipmiuser -P $ipmipass -I lanplus power off";
	$return=exec($cmd);
	if($return ==""){
		$status = "fail";
	}else{
		$status = "success";
	}
	return $status;
}
// 开机
function ipmi_powerOn($params) {
	$ipmiip = $params['customfields']["ipmiip"];
	$ipmiuser = $params['customfields']["ipmiuser"];
	$ipmipass = $params['customfields']["ipmipass"];
	$cmd="ipmitool -H $ipmiip -U $ipmiuser -P $ipmipass -I lanplus power on";
	$return=exec($cmd);
	if($return ==""){
		$status = "fail";
	}else{
		$status = "success";
	}
	return $status;
}

//重置
function ipmi_cycle($params) {
	$ipmiip = $params['customfields']["ipmiip"];
	$ipmiuser = $params['customfields']["ipmiuser"];
	$ipmipass = $params['customfields']["ipmipass"];
	$cmd="ipmitool -H $ipmiip -U user -P $pass -I lanplus power cycle";
	$return=exec($cmd);
	if($return ==""){
		$status = "fail";
	}else{
		$status = "success";
	}
	return $status;
}

// 重启模式
function ipmi_bootdev($params) {
	$code = $_GET['a'];
	if (empty($code)){return "缺少必要参数";}
	$ipmiip = $params['customfields']["ipmiip"];
	$ipmiuser = $params['customfields']["ipmiuser"];
	$ipmipass = $params['customfields']["ipmipass"];
	$cmd="ipmitool -H $ipmiip -U $ipmiuser -P $ipmipass -I chassis bootdev $code";
	$return=exec($cmd);
	if($return ==""){
		$status = "fail";
	}else{
		$status = "success";
	}
	return $status;
}

function ipmi_ClientAreaCustomButtonArray() {
	$buttonarray = [
		"打开电源"  => "powerOn",
		"关闭电源"  => "powerOff",
		"重启"   => "reboot",
		"重置IPMI"  => "cycle",
		"重启到"  => "bootdev",
	];
	return $buttonarray;
}

function ipmi_AdminCustomButtonArray() {
	$buttonarray = [
		"打开电源"  => "powerOn",
		"关闭电源"  => "powerOff",
		"重启"   => "reboot",
		"重置IPMI"  => "cycle",
		"重启到"  => "bootdev",
	];
	return $buttonarray;
}

function ipmi_getchassispower($params) {
	$cmd = "ipmitool -H ".$params['customfields']["ipmiip"]." -U ".$params['customfields']["ipmiuser"]." -P ".$params['customfields']["ipmipass"]." -I lanplus power status";
	return exec($cmd);
}

function ipmi_ClientArea($params) {

	$ipmiip = $params['customfields']["ipmiip"];
	$ipmiuser = $params['customfields']["ipmiuser"];
	$ipmipass = $params['customfields']["ipmipass"];

	if ($_GET["a"] == "getchassispower") {
		$result = ipmi_getchassispower($params);
		if (strpos($result,"on") != false) {
			exit("on");
		} else
			if(strpos($result,"off") != false) {
				exit("off");
			} else {
			exit("unknow");
		}
	}

	return [
	'tabOverviewReplacementTemplate' => 'skin',
	'templateVariables' => [
			'notes'   			=> $params["customfields"]["notes"], 		// 备注
			'datacenter'  		=> $params["customfields"]["datacenter"], 	// 数据中心
			'bandwidth'  		=> $params["customfields"]["bandwidth"], 	//带宽
			'defense'   		=> $params["customfields"]["defense"], 		// 防御
			'ipmi_username' 	=> $params["customfields"]["ipmiuser"], 	// ipmiuser
			'ipmi_password' 	=> $params["customfields"]["ipmipass"], 	// ipmi pass
			'ipmi_ip'   		=> $params['customfields']["ipmiip"],		// ipmi ip
			'CustomerService'   => $params['customfields']["CustomerService"],	// 自定义服务
		]
	];
}